<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 04/02/2005 *
 * ===============                              Last change: 05/19/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : sponsor.php                                      *
 * -------------------------------------------------------------------- *
 * Short description : Sponsor area                                     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Sponsorenbereich                                 *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software. You can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License.       *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
} elseif ((!EXT_IS_ACTIVE('sponsor'))) {
	addFatalMessage(__FILE__, __LINE__, generateExtensionInactiveNotInstalledMessage('sponsor'));
	return;
} elseif (!IS_SPONSOR()) {
	// No sponsor!
	addFatalMessage(__FILE__, __LINE__, getMessage('SPONSOR_ONLY_AREA_ENTERED'));
	return;
} elseif (empty($GLOBALS['what'])) {
	// Empty what value detected!
	$GLOBALS['what'] = "welcome";
}

// A valid sponsor login and we are allowed to enter this module so let's
// update his cookies and online time
UPDATE_SPONSOR_LOGIN();

// Generate menu
define('__SPONSOR_MENU', GENERATE_SPONSOR_MENU($GLOBALS['what']));

// Generate right-side output
define('__SPONSOR_CONTENT', GENERATE_SPONSOR_CONTENT($GLOBALS['what']));

// Load header template
define('__SPONSOR_HEADER', LOAD_TEMPLATE("sponsor_header", true));

// Load footer template
define('__SPONSOR_FOOTER', LOAD_TEMPLATE("sponsor_footer", true));

// "You are here" navigation
define('__SPONSOR_YOURE_HERE', ADD_DESCR('sponsor', $GLOBALS['what'], false, false));

// Load main sponsor template
LOAD_TEMPLATE("sponsor_main");

//
?>
